20.15. Preset Options

|          20.15. Preset Options           |                         |                                |                  |                                   |
|:----------------------------------------:|-------------------------|--------------------------------|------------------|-----------------------------------|
|[Prev](runtime-config-error-handling.html)|[Up](runtime-config.html)|Chapter 20. Server Configuration|[Home](index.html)| [Next](runtime-config-custom.html)|

---

## 20.15. Preset Options

 The following “parameters” are read-only. As such, they have been excluded from the sample `postgresql.conf` file. These options report various aspects of PostgreSQL behavior that might be of interest to certain applications, particularly administrative front-ends. Most of them are determined when PostgreSQL is compiled or when it is installed.

`block_size` (`integer`) []()

 Reports the size of a disk block. It is determined by the value of `BLCKSZ` when building the server. The default value is 8192 bytes. The meaning of some configuration variables (such as [shared\_buffers](runtime-config-resource.html#GUC-SHARED-BUFFERS)) is influenced by `block_size`. See [Section 20.4](runtime-config-resource.html) for information.

`data_checksums` (`boolean`) []()

 Reports whether data checksums are enabled for this cluster. See [data checksums](app-initdb.html#APP-INITDB-DATA-CHECKSUMS) for more information.

`data_directory_mode` (`integer`) []()

 On Unix systems this parameter reports the permissions the data directory (defined by [data\_directory](runtime-config-file-locations.html#GUC-DATA-DIRECTORY)) had at server startup. (On Microsoft Windows this parameter will always display `0700`.) See [group access](app-initdb.html#APP-INITDB-ALLOW-GROUP-ACCESS) for more information.

`debug_assertions` (`boolean`) []()

 Reports whether PostgreSQL has been built with assertions enabled. That is the case if the macro `USE_ASSERT_CHECKING` is defined when PostgreSQL is built (accomplished e.g., by the `configure` option `--enable-cassert`). By default PostgreSQL is built without assertions.

`integer_datetimes` (`boolean`) []()

 Reports whether PostgreSQL was built with support for 64-bit-integer dates and times. As of PostgreSQL 10, this is always `on`.

`in_hot_standby` (`boolean`) []()

 Reports whether the server is currently in hot standby mode. When this is `on`, all transactions are forced to be read-only. Within a session, this can change only if the server is promoted to be primary. See [Section 27.4](hot-standby.html) for more information.

`lc_collate` (`string`) []()

 Reports the locale in which sorting of textual data is done. See [Section 24.1](locale.html) for more information. This value is determined when a database is created.

`lc_ctype` (`string`) []()

 Reports the locale that determines character classifications. See [Section 24.1](locale.html) for more information. This value is determined when a database is created. Ordinarily this will be the same as `lc_collate`, but for special applications it might be set differently.

`max_function_args` (`integer`) []()

 Reports the maximum number of function arguments. It is determined by the value of `FUNC_MAX_ARGS` when building the server. The default value is 100 arguments.

`max_identifier_length` (`integer`) []()

 Reports the maximum identifier length. It is determined as one less than the value of `NAMEDATALEN` when building the server. The default value of `NAMEDATALEN` is 64; therefore the default `max_identifier_length` is 63 bytes, which can be less than 63 characters when using multibyte encodings.

`max_index_keys` (`integer`) []()

 Reports the maximum number of index keys. It is determined by the value of `INDEX_MAX_KEYS` when building the server. The default value is 32 keys.

`segment_size` (`integer`) []()

 Reports the number of blocks (pages) that can be stored within a file segment. It is determined by the value of `RELSEG_SIZE` when building the server. The maximum size of a segment file in bytes is equal to `segment_size` multiplied by `block_size`; by default this is 1GB.

`server_encoding` (`string`) []() []()

 Reports the database encoding (character set). It is determined when the database is created. Ordinarily, clients need only be concerned with the value of [client\_encoding](runtime-config-client.html#GUC-CLIENT-ENCODING).

`server_version` (`string`) []()

 Reports the version number of the server. It is determined by the value of `PG_VERSION` when building the server.

`server_version_num` (`integer`) []()

 Reports the version number of the server as an integer. It is determined by the value of `PG_VERSION_NUM` when building the server.

`ssl_library` (`string`) []()

 Reports the name of the SSL library that this PostgreSQL server was built with (even if SSL is not currently configured or in use on this instance), for example `OpenSSL`, or an empty string if none.

`wal_block_size` (`integer`) []()

 Reports the size of a WAL disk block. It is determined by the value of `XLOG_BLCKSZ` when building the server. The default value is 8192 bytes.

`wal_segment_size` (`integer`) []()

 Reports the size of write ahead log segments. The default value is 16MB. See [Section 30.5](wal-configuration.html) for more information.

---

|[Prev](runtime-config-error-handling.html)|[Up](runtime-config.html)| [Next](runtime-config-custom.html)|
|:-----------------------------------------|:-----------------------:|----------------------------------:|
|          20.14. Error Handling           |   [Home](index.html)    |     20.16. Customized Options     |

 // \<![CDATA[ \<-- For SVG support if ('WebSocket' in window) { (function() { function refreshCSS() { var sheets = [].slice.call(document.getElementsByTagName("link")); var head = document.getElementsByTagName("head")[0]; for (var i = 0; i \< sheets.length; ++i) { var elem = sheets[i]; head.removeChild(elem); var rel = elem.rel; if (elem.href && typeof rel != "string" || rel.length == 0 || rel.toLowerCase() == "stylesheet") { var url = elem.href.replace(/(&|\\?)\_cacheOverride=\\d+/, ''); elem.href = url + (url.indexOf('?') \>= 0 ? '&' : '?') + '\_cacheOverride=' + (new Date().valueOf()); } head.appendChild(elem); } } var protocol = window.location.protocol === 'http:' ? 'ws://' : 'wss://'; var address = protocol + window.location.host + window.location.pathname + '/ws'; var socket = new WebSocket(address); socket.onmessage = function(msg) { if (msg.data == 'reload') window.location.reload(); else if (msg.data == 'refreshcss') refreshCSS(); }; console.log('Live reload enabled.'); })(); } // ]]\>